/* ==== aroll_histo.c ==== */
/* generates histograms of attackroll output */

#include "attackroll.h"

void main() {
   unsigned long max=0;
   unsigned long bucket[220];
   short r;
   char cmdbuf[100];
   unsigned long i;
   for(i=0;i<220;i++) bucket[i]=0;
   for(i=0;i<1048576;i++) {
     r=attackroll()+110;
     if(r<0||r>=219) {printf("Rolled out of range!\n");exit(1);}
     bucket[r]++;
#if 0
     printf("%+04d ",r-110);
#endif
   }
#if 0
   exit(0);
#endif

   /* now dump them or something */
   for(i=0;i<220;i++) if (bucket[i]>max) max=bucket[i];
   /* Try to scale down so max=1024; */
   max++;
#if 0
   for(i=0;i<220;i++) bucket[i]=bucket[i]*(1020.0/max);
   max=1024; /* that'll do */
#else
   for(i=70;i<150;i++) bucket[i]=bucket[i]*(250.0/max);
   max=256;
#endif
/*  */
   sprintf(cmdbuf,"ppmmake 0,0,0 2 %d |pnmtopng >totbar.png",max);
   system(cmdbuf);
#if 0
   for(i=0;i<220;i++) {
#else
   for(i=70;i<150;i++) {
#endif
      sprintf(cmdbuf,"ppmmake rgbi:1/1/1   1 %d >whitebar.ppm",max-bucket[i]);
      system(cmdbuf);
      if(bucket[i]) {
       /* WAS purple, changed my mind to make it faster */
       sprintf(cmdbuf,"ppmmake rgbi:0/0/0  1 %d >purpbar.ppm",bucket[i]);
       system(cmdbuf);
      }
      if(bucket[i]) {
       system("pnmcat -topbottom whitebar.ppm purpbar.ppm  >newbar.ppm");
      } else {
       system("mv whitebar.ppm newbar.ppm");
      }
      system("mv totbar.png tmpbar.png");
      system("pngtopnm tmpbar.png|pnmcat -lr - newbar.ppm |pnmtopng >totbar.png");
   }
}


#define D4() (random()%4)
#define D6() (random()%6)
#define D8() (random()%8)
#define D10() (random()%10)
#define D12() (random()%12)
#if 0
#define USE_D20(die) (tmp=die),(die=(die+1)%20),tmp
#else
#define D20() (random()%20)
#endif

